<?php

namespace Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;
use Modules\Parametros\Services\Sup03501ParametrizacaoAcordoFornecedorService;
use Zeedhi\Framework\DTO\Response\Error;

class Sup03501ParametrizacaoAcordoFornecedorController extends \Teknisa\GER\Controllers\TeknisaCrud
{
    
    public function __construct($crudService, $parameterBag, Sup03501ParametrizacaoAcordoFornecedorService $service)
    {
        $this->crudService = $crudService;
        $this->service  = $service;
    }
    
    public function saveAgreement(DTO\Request\DataSet $request, DTO\Response $response)
	{
		try {
            $rows = $request->getDataSet()->getRows();
            
			$procedureResult = $this->service->procedureSaveAgreement($rows[0]);
			if($procedureResult['P_RESULTADO'] == 'NAO_INSERT'){
			    $msg[0] = 'Não ha dados para adicionar acordo!';
			 
			} else {
			    $msg[0] = 'Operação realizada com sucesso!';
			}
			$response->addDataSet(new DataSet('msg', $msg));
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}

    public function autoDeleteAgreement(DTO\Request\DataSet $request, DTO\Response $response)
	{
		try {
            $rows = $request->getDataSet()->getRows();
            
            $cdgrupprod = $this->service->selectCdgrupprod()[0]['CDGRUPPROD'];
            
            $rows[0]['CDGRUPPROD'] = $cdgrupprod;
            if(!empty($rows[0])) {
            	$this->service->autoDeleteAgreement($rows[0]);
            } else {
            	$response->addMessage(new Message("Não há dados para atualização."));
            }
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	public function updateAgreement(DTO\Request\DataSet $request, DTO\Response $response)
	{
		try {
            $rows = $request->getDataSet()->getRows();
            
            $cdgrupprod = $this->service->selectCdgrupprod()[0]['CDGRUPPROD'];
            $row = $rows[0];
            $row['CDGRUPPROD'] = $cdgrupprod;
            $itens = $this->service->selectAtualizacao($row);

		    if(!empty($itens)) {
    		    foreach($itens as $item) {
    		        $this->service->deleteAtualizacao($item, $cdgrupprod);
    		        $this->service->insertAtualizacao($item, $row);
		        }  
		    } else {
				$response->addMessage(new Message("Não há dados para atualização."));
		    }
		} catch (\Exception $e) {
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
}